// ===========================================================================
//	LCGIApplication.h				1995 Brian Todoroff  All rights reserved.
// ===========================================================================
//
//  Commercial or for-profit use subject to licence.  Contact btodorof@hmc.edu.
//
//  If you use this class in your application please let me know.
//
//	This class may only be distributed with the complete CGI++ Framework
//  package.  For further information contact the author at btodorof@hmc.edu.
//

#pragma once

#include <LApplication.h>
#include "LCHandleStream.h"

typedef struct {
	char *	direct;
	char *	search;
	char *	uname;
	char *	pass;
	char *	fromuser;
	char *	caddr;
	char *	post;
	char *	method;
	char *	sname;
	char *	sport;
	char *	cginame;
	char *	ctype;
	char *	referer;
	char *	agent;
	} CGIData;
	

class	LCGIApplication : public LApplication {
public:
						LCGIApplication();		
	virtual 			~LCGIApplication();		
	
	virtual void 		FindCommandStatus( CommandT	inCommand,
									Boolean &outEnabled,
									Boolean &outUsesMark,
									Char16 &outMark,
									Str255 outName);
	
	virtual void		HandleAppleEvent( const AppleEvent &inAppleEvent,
							AppleEvent			&outAEReply,
							AEDesc				&outResult,
							long				inAENumber);
	virtual Boolean 	ObeyCommand(CommandT inCommand,	void *ioParam);


	// This function should be over-ridden to respond to the CGI call
	// data contains the information passed from MacHTTP
	// sout should be filled with the return data
	virtual	void		HandleCGICall(CGIData &,LCHandleStream &);
						
protected:

	virtual void		StartUp();		// overriding startup functions
};