// ===========================================================================
//	LCHandleStream.h				1995 Brian Todoroff All rights reserved.
//  Version 1.0b
// ===========================================================================
//
//  This class may only be distributed as part of the CGI++ Framework.  For
//  further information contact the author at btodorof@hmc.edu.
//
//	A subclass of LHandleStream that adds << operators for output. This version
//	includes special modifiers for HTML.

#pragma once

#include <LHandleStream.h>
#include <stdio.h>
#include <string.h>

class	LCHandleStream : public LHandleStream {
public:
					LCHandleStream();
					LCHandleStream( Handle inHandle);
					~LCHandleStream();
					
	virtual Int32	WriteCStr(const void *inString);
					LCHandleStream &operator<<(char *inStr);
					LCHandleStream &operator<<(Handle inH);
					LCHandleStream &operator<<(char inChar);
					LCHandleStream &operator<<(int inInt);
					LCHandleStream& operator<<(LCHandleStream& (*_F)(LCHandleStream&))
						{return ((*_F)(*this)); }


};	

LCHandleStream &endl(LCHandleStream &stream);	// Text and HTML line break
LCHandleStream &brkl(LCHandleStream &stream);	// HTML line break
LCHandleStream &crlf(LCHandleStream &stream);	// Text CR and LF (DOS line break)
LCHandleStream &newl(LCHandleStream &stream);	// Text CR (Mac line break)

