/*
	CPasswordField.h

	History:	
		Wed, 30 Aug 1995	Peter Marks	Created.

*/

#pragma once

#include "LEditField.h"


class CPasswordField : public LEditField
{
// Lets the user type into a field, only shows bullet characters
// Disable cut and copy
public:
	enum { class_ID = 'PASW' };
	
	CPasswordField();
	CPasswordField(LStream *inStream);
	virtual ~CPasswordField();
	static LEditField*	CreatePasswordFieldStream(LStream *inStream); // Override

	virtual StringPtr	GetDescriptor(
								Str255				outDescriptor) const; // Override

	virtual void		SetDescriptor(
								ConstStr255Param	inDescriptor); // Override

	virtual void		FindCommandStatus(
								CommandT			inCommand,
								Boolean				&outEnabled,
								Boolean				&outUsesMark,
								Char16				&outMark,
								Str255				outName); // Override

	virtual Boolean		HandleKeyPress(
								const EventRecord	&inKeyEvent); // Override

	virtual void ClickSelf(const SMouseDownEvent &inMouseDown);
private:
	Str255	mContent;	// the actual password they typed
};
