// ===========================================================================
//		 LTask.h					 1995, ric Forget. All rights reserved.
// ===========================================================================
//
//	************************************************************************
//	*                                                                      *
//	*	Before using this code you should read the "License Agreement"     *
//	*	document and agree with it.                                        *
//	*                                                                      *
//	************************************************************************
//
//	Instruction and usage notes are in the LTask.cp file.
//
// ---------------------------------------------------------------------------


#pragma once


// ---------------------------------------------------------------------------
//		 Class LTask
// ---------------------------------------------------------------------------

class LTask {

public:
								LTask();
								LTask(	Int32	inFirstDelay,
										Int32	inNextDelay,
										Boolean inDeleteOnCompletion);
	virtual						~LTask();
	
	virtual void				StartTask();
	virtual void				StopTask();
	
	Boolean						HasDeleteOnCompletion()
								{
									return mDeleteOnCompletion;
								}
	void						SetDeleteOnCompletion(Boolean inHasDeleteOnCompletion)
								{
									mDeleteOnCompletion = inHasDeleteOnCompletion;
								}
	Int32						GetFirstDelay()
								{
									return mFirstDelay;
								}
	void						SetFirstDelay(Int32 inFirstDelay)
								{
									mFirstDelay = inFirstDelay;
								}
	
	Int32						GetNextDelay()
								{
									return mNextDelay;
								}
	void						SetNextDelay(Int32 inFirstDelay)
								{
									mFirstDelay = inFirstDelay;
								}
	
	Boolean						IsExecuting()
								{
									return mIsExecuting;
								}
	
protected:
	Int32						mFirstDelay;
	Int32						mNextDelay;
	Boolean						mIsExecuting;
	Boolean						mDeleteOnCompletion;
	
	
	virtual void				ExecuteTask();
	virtual void				ContinueTask();
	
	virtual void				StartTaskSelf() = 0;
	virtual void				ExecuteTaskSelf(Boolean &ioLastCall) = 0;
	virtual void				StopTaskSelf() = 0;
};
