/*****************************************************************************
	
	LDimmableView.h
	Written by Rick Eames
	1994 Natural Intelligence, Inc. && Rick Eames
	
	This class exists for one purpose only: to gray out a view that has 
	been disabled.  This includes graying out all of the subviews within
	that view.  To accomplish this, LDimmableView orders all of the sub-
	views and attachments to draw themselves, checks to see if the view
	is in a disabled state and grays out the view if it is. 
	
	The code also does the right thing if running under color.
	
	You have permission to use this class in any application you develop
	as long as you credit both Rick Eames and Natural Intelligence, Inc. in
	your credits.
	
*****************************************************************************/


#pragma once

#include <LView.h>
#include <LStream.h>

class LDimmableView : public LView
{
public:
	LDimmableView(LStream *inStream);
	static LDimmableView *CreateDimmableViewStream(LStream *inStream);
	
	void DimInColor(Rect *inDrawRect, unsigned short tint, Boolean makeLighter);
	
	void Draw(RgnHandle inSuperDrawRgnH);

};
