/*	NAME:
		LPasswordField.h

	WRITTEN BY:
		Dair Grant, dair@kagi.com
				
	DESCRIPTION:
		Header file for LPasswordField.cp.

	___________________________________________________________________________
*/
#ifndef __LPASSWORDFIELD__
#define __LPASSWORDFIELD__
//=============================================================================
//		Include files
//-----------------------------------------------------------------------------
#include <LEditField.h>















//=============================================================================
//		Class definition
//-----------------------------------------------------------------------------
class LPasswordField : public LEditField {
public:
	enum { class_ID = 'pass' };
	static LPasswordField		*CreatePasswordFieldStream(LStream *inStream);

								LPasswordField();
								LPasswordField(const LPasswordField &inOriginal);
								LPasswordField(const	SPaneInfo			&inPaneInfo,
														Str255				inString,
														ResIDT				inTextTraitsID,
														Int16				inMaxChars,
														Boolean				inHasBox,
														Boolean				inHasWordWrap,
														KeyFilterFunc		inKeyFilter,
														LCommander			*inSuper);
								LPasswordField(const	SPaneInfo			&inPaneInfo,
														Str255				inString,
														ResIDT				inTextTraitsID,
														Int16				inMaxChars,
														Uint8				inAttributes,
														KeyFilterFunc		inKeyFilter,
														LCommander			*inSuper);
								LPasswordField(LStream *inStream);
	virtual						~LPasswordField();

	
	virtual void				SetDescriptor(ConstStr255Param inDescriptor);
	virtual void				SetBullet(Int16 inBullet);
	virtual void				SetTextTraitsID(ResIDT inTextTraitsID);


	virtual Boolean				ObeyCommand(CommandT inCommand, void *ioParam);
	virtual void				FindCommandStatus(CommandT				inCommand,
													Boolean				&outEnabled,
													Boolean				&outUsesMark,
													Char16				&outMark,
													Str255				outName);
	virtual	void				SpendTime(const EventRecord	&inMacEvent);
	
	virtual Boolean				HandleKeyPress(const EventRecord &inKeyEvent);
	
	virtual void				SelectAll();
	
	virtual void				SavePlace(LStream *outPlace);
	virtual void				RestorePlace(LStream *inPlace);


			
protected:
	TEHandle					mBulletTextEditH;
	Int16						mBullet;
	
	
	virtual void				DrawSelf();	
	
	virtual void				ClickSelf(const SMouseDownEvent &inMouseDown);
	
	virtual void				BeTarget();
	virtual void				DontBeTarget();
	
	virtual void				AlignTextEditRects();
	virtual void				AdjustTextWidth(Boolean inShrinkToText);
									
	virtual void				SetTextToBullets(TEHandle theTextHnd);
	virtual void				SetVisibleFromHidden(void);


			
private:
	void						InitPassField(Uint8 inAttributes);
};


#endif